
    Program
   !APP hook

 INCLUDE('WINEQU.CLW')

JdaMessage              Equate(0)
DWord                   Equate(Ulong)
Handle                  Equate(Unsigned)
hHook                   Equate(Handle)
hInstance               Equate(Handle)
Null                    Equate(0)
!--
cWindowText   CSTRING(128)
cClassName    CSTRING(128)
hwnd          HANDLE
hwndtarget    HANDLE
eWM_GETTEXT     EQUATE(0dh)
eWM_SETTEXT     EQUATE(0ch)
eWM_CLOSE       EQUATE(0010h)
eWM_USER        EQUATE(0400h)
LOC:Result    UNSIGNED
Linija        CSTRING(255)

    Map
        HookProcedure(Short,Long,Long),DWord,Pascal
        InstallHook
        RemoveHook
        Module('Windows API')
            LoadLibrary(Long),Long,Raw,Pascal,Name('LoadLibraryA')
            GetProcAddress(Long,Long),Long,Raw,Pascal
            UnhookWindowsHookEx(Long),Bool,Raw,Pascal
            SetWindowsHookEx(Long,Long,Long,Long),Long,Raw,Pascal,Name('SetWindowsHookExA')
            CallNextHookEx(Long,Long,Long,Long),Long,Raw,Pascal
            !--
            GetClassName(HWND,*LPSTR,SIGNED),SIGNED,PASCAL,RAW,NAME('GetClassNameA')
            !FindWindow(*LPCSTR,*LPCSTR),HWND,PASCAL,RAW,NAME('FindWindowA')
            FindWindow(ULONG,ULONG),HWND,PASCAL,RAW,NAME('FindWindowA')
            SendMessageTimeout(UNSIGNED,UNSIGNED,UNSIGNED,LONG,UNSIGNED,UNSIGNED,*UNSIGNED),LONG,RAW,PASCAL,NAME('SendMessageTimeoutA'),PROC
            SendMessage(UNSIGNED,UNSIGNED,UNSIGNED,LONG),LONG,RAW,PASCAL,NAME('SendMessageA'),PROC
            SetWindowText(HWND,*LPCSTR),BOOL,PASCAL,NAME('SetWindowTextA')
      End
    End

HookVars            Group,Pre(HV)
InstalledOk                 Byte        ! Did we install the hook OK?
Hook                        hHook       ! Handle to the current hook procedure
PrevHook                    hHook       ! Handle to the previous hook procedure
                    End

    Code

! *******************************************************************************************************************
InstallHook Procedure
! *******************************************************************************************************************
LocalVars               Group,Pre(Loc)
DLLName                     CString(20)
DllNamePtr                  ULong
KHName                      CString(50)
KHNamePtr                   Ulong
MHName                      CString(50)
MHNamePtr                   Ulong
ThreadID                    DWord
DLLInstance                 hInstance
                        End

! Valid Hook types
WH_Min                  Equate(-1)
WH_MsgFilter            Equate(-1)
WH_JournalRecord        Equate(0)
WH_JournalPlayback      Equate(1)
WH_Keyboard             Equate(2)
WH_GetMessage           Equate(3)
WH_CallWndProc          Equate(4)
WH_CBT                  Equate(5)
WH_SysMsgFilter         Equate(6)
WH_Mouse                Equate(7)
WH_Hardware             Equate(8)
WH_Debug                Equate(9)
WH_Shell                Equate(10)

    Code
        HV:InstalledOK = False
        Loc:DLLName = 'DLL32.DLL'
        Loc:DllNamePtr = Address(Loc:DLLName)
        Loc:DLLInstance = LoadLibrary( Loc:DllNamePtr )
        If Loc:DLLInstance <> 0 Then
            Loc:KHName = 'HookProcedure'
            Loc:MHNamePtr = Address(Loc:KHName)
            HV:Hook = GetProcAddress(Loc:DLLInstance,Loc:MHNamePtr)
            If HV:Hook <> 0 Then
                HV:PrevHook = SetWindowsHookEx( WH_SHELL , HV:Hook, Loc:DLLInstance, 0)
                If HV:PrevHook = 0 Then
                    HV:InstalledOK = True
                End
            End
        End

!-------------
     cWindowText='AHook'
     dummy#=0
     HWNDtarget=FindWindow(dummy#,ADDRESS(cWindowText))
     IF HWNDtarget
        cWindowText='AHook activated'
        r#=SendMessageTimeout(HwndTarget,eWM_SETTEXT,SIZE(cWindowText)-1, |
        ADDRESS(cWindowText),2,100,LOC:Result)
     END

! *******************************************************************************************************************
HookProcedure Function (Prm:nCode, Prm:wparam, Prm:lparam)
! *******************************************************************************************************************
LocalVars               Group,Pre(Loc)
ProcessedEvent              Byte
ReturnValue                 DWord
                        End
Key_Up                  Equate(10000000000000000000000000000000B)
HSHELL_ACTIVATESHELLWINDOW  EQUATE(3)
HSHELL_GETMINRECT           EQUATE(5)
HSHELL_LANGUAGE             EQUATE(8)
HSHELL_REDRAW               EQUATE(6)
HSHELL_TASKMAN              EQUATE(7)
HSHELL_WINDOWACTIVATED      EQUATE(4)
HSHELL_WINDOWCREATED       EQUATE(1)
HSHELL_WINDOWDESTROYED     EQUATE(2)

    Code

        If Prm:nCode < 0
            Loc:ProcessedEvent = False
        Else
          IF Prm:nCode=HSHELL_WINDOWCREATED
             cWindowText='AHook activated'
             dummy#=0
             HWNDtarget=FindWindow(dummy#,ADDRESS(cWindowText))
             if HWNDtarget
                r#=SendMessageTimeout(HwndTarget,eWM_USER,Prm:wparam,Prm:lparam  |
                   ,2,100,LOC:Result)
             end
          END
          !OR local action
          !If Prm:nCode=HSHELL_WINDOWCREATED
          !   IF GetClassName(Prm:wparam,cClassName,size(cClassName))
          !      dummy#=0
          !      HWND=FindWindow(ADDRESS(cClassName),dummy#)
          !      if HWND and HWNDtarget
          !         !r#=SendMessageTimeout(HWND,eWM_GETTEXT,SIZE(cWindowText)-1 , |
          !         !ADDRESS(cWindowText),2,100,LOC:Result)
          !         !aljem handle nove app
          !         r#=SendMessageTimeout(HwndTarget,eWM_USER,HWND,1  |
          !         ,2,100,LOC:Result)
          !      end
          !   END
          !End
          Loc:ReturnValue=1
          Loc:ProcessedEvent = True

        End
        If ~Loc:ProcessedEvent
            Loc:ReturnValue = CallNextHookEx(HV:PrevHook, Prm:nCode, Prm:wParam, Prm:lParam)
        End

        Return( Loc:ReturnValue )

! *******************************************************************************************************************
RemoveHook Procedure
! *******************************************************************************************************************
    Code
        If HV:InstalledOK = True
            x# = UnhookWindowsHookEx( HV:PrevHook )
        End

   


